package lib::Config;

use FindBin qw($Bin);
use lib $Bin;
use File::Path;
use NNML::Config qw($Config);
use Exporter;
@ISA = (Exporter);
@EXPORT = qw($config $userstempl $users $datefile
	     $daily $expiretxt $expirelist $hooks);
@EXPORT_OK = qw($basefile);

my $etc = "$Bin/etc";
my $var = "$Bin/var";

$basefile = "$etc/base.txt";
$config = "$etc/config.pl";
$hooks = "$Bin/lib/hooks.pl";
$userstempl = "$etc/users_templ.txt";
$users = "$var/users.txt";
$datefile = "$var/date.txt";
$expiretxt = "$etc/expire.txt";
$daily = "$var/daily.txt";
$expirelist = "$var/expirelist.txt";

$ENV{USER} ||= 'dummy';
$ENV{HOME} ||= 'C:/dummy';

my $base = readbase();
mkbase($base) if ! -d $base;

$Config->base($base);
$Config->{ngs} = $Config->base . "/newsgroups";

mkactive($base) if ! -f $Config->active;

sub readbase {
    open(BASE, "<$basefile") or die "Cannot open $basefile: $!";
    my $base = <BASE>;
    chomp $base;

    return $base;
}

sub mkbase {
    my $base = shift;

    return if -d $base;

    mkpath $base or die "Cannot make directory $base: $!";
}

sub mkactive {
    my $active = $Config->active;

    return if -f $active;

    open(ACTIVE, ">$active") or die "Cannot open $active: $!";
    close(ACTIVE);
}

1;

# end

