package lib::Header;

use NNML::Active qw($ACTIVE);
use NNML::Group;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(fetch_header article_header);

sub fetch_header {
    my $art = shift;
    my $hd = {};
    my $h = '';
    my $v;

    my ($head, $body) = split /^$/m, $art, 2;
    my @header = split /\n/, $head;
    for (@header) {
	$hd->{lc $h} .= "$_\n", next if $h and /^\s/;
	($h, $v) = split /:\s+/, $_, 2;
	$hd->{lc $h} = $v;
    }

    return ($hd, $body);
}

sub article_header {
    my $id = shift;
    my $group;
    my ($head, $body) = ();

    for $group ($ACTIVE->groups) {
	my $ano = $group->article_by_id($id);
	next unless defined $ano;
	($head, $body) = $group->get($ano);
	last if defined $head;
    }

    return fetch_header($head);
}

1;

# end
