# spam filter

package lib::SpamFilter;

use NNML::Config qw($Config);
use lib::Header;

push @{$Config->{accept_article_hook}}, \&spam_filter;

my $poison_group = "alt.*,*.binaires.*";

sub spam_filter {
    my $art = shift;
    my $head = fetch_header($art);
    my @mygroup = split /,/, $head->{newsgroups};
    my $group = $poison_group;
    my $ret = "poison group: ";

    $group =~ s/\./\\./g;
    $group =~ s/\*/.*/g;
    my @grouppat = split /,/, $group;
    my $neg = join '|', grep /^[^!]/, @grouppat;
    my $pos = join '|', grep s/^!//, @grouppat;

    for (@mygroup) {
	next if $pos and /^($pos)$/;
	return $ret . $_ . "\n" if $neg and /^($neg)$/;
    }

    return 0;
}

1;

# end
