#!perl

use lib::Config;
use NNML::Auth;
use NNML::Config qw($Config);

open(TEMPL, "<$userstempl") or die "Cannot open $userstempl: $!";
open(USERS, ">$users") or die "Cannot open $users: $!";

unlink $Config->passwd if -e $Config->passwd;
while (<TEMPL>) {
    next if /^$/ or /^#/;
    my ($user, $pass, @perm) = split;
    $pass = mkpasswd() if $pass eq '*';
    print USERS "$user $pass @perm\n";
    NNML::Auth::add_user($user, $pass, @perm);
}
close(USERS);
close(TEMPL);

sub mkpasswd {
    my $max = 8;
    my @salt = ('A'..'Z', 'a'..'z', '0'..'9');
    my $password = '';

    for (1 .. $max) {
	$password .= "$salt[int(rand($#salt+1))]";
    }

    return $password;
}

# end
